test_abd_verify.sh 3.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687
  1. #!/usr/bin/env bash
  2. trap "gnunet-arm -e -c test_abd_lookup.conf" SIGINT
  3. LOCATION=$(which gnunet-config)
  4. if [ -z $LOCATION ]
  5. then
  6. LOCATION="gnunet-config"
  7. fi
  8. $LOCATION --version 1> /dev/null
  9. if test $? != 0
  10. then
  11. echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
  12. exit 77
  13. fi
  14. rm -rf `gnunet-config -c test_abd_lookup.conf -s PATHS -o GNUNET_HOME -f`
  15. # (1) Service.user -> GNU.project.member
  16. # (2) GNU.project -> GNUnet
  17. # (3) GNUnet.member -> GNUnet.developer
  18. # (4) GNUnet.member -> GNUnet.user
  19. # (5) GNUnet.developer -> Alice
  20. which timeout > /dev/null 2>&1 && DO_TIMEOUT="timeout 30"
  21. gnunet-arm -s -c test_abd_lookup.conf
  22. gnunet-identity -C service -c test_abd_lookup.conf
  23. gnunet-identity -C alice -c test_abd_lookup.conf
  24. gnunet-identity -C gnu -c test_abd_lookup.conf
  25. gnunet-identity -C gnunet -c test_abd_lookup.conf
  26. GNU_KEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep gnu | grep -v gnunet | awk '{print $3}')
  27. ALICE_KEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep alice | awk '{print $3}')
  28. GNUNET_KEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep gnunet | awk '{print $3}')
  29. SERVICE_KEY=$(gnunet-identity -d -c test_abd_lookup.conf | grep service | awk '{print $3}')
  30. USER_ATTR="user"
  31. GNU_PROJECT_ATTR="project"
  32. MEMBER_ATTR="member"
  33. DEVELOPER_ATTR="developer"
  34. DEV_ATTR="developer"
  35. TEST_CREDENTIAL="mygnunetcreds"
  36. gnunet-identity -d
  37. # (1) A service assigns the attribute "user" to all entities that have been assigned "member" by entities that werde assigned "project" from GNU
  38. gnunet-abd --createIssuerSide --ego=service --attribute="$USER_ATTR" --subject="$GNU_KEY $GNU_PROJECT_ATTR.$MEMBER_ATTR" --ttl="2019-12-12 10:00:00" -c test_abd_lookup.conf
  39. gnunet-namestore -D -z service
  40. # (2) GNU recognized GNUnet as a GNU project and delegates the "project" attribute
  41. gnunet-abd --createIssuerSide --ego=gnu --attribute="$GNU_PROJECT_ATTR" --subject="$GNUNET_KEY" --ttl="2019-12-12 10:00:00" -c test_abd_lookup.conf
  42. gnunet-namestore -D -z gnu
  43. # (3+4) GNUnet assigns the attribute "member" to all entities gnunet has also assigned "developer" or "user"
  44. gnunet-abd --createIssuerSide --ego=gnunet --attribute="$MEMBER_ATTR" --subject="$GNUNET_KEY $DEVELOPER_ATTR" --ttl="2019-12-12 10:00:00" -c test_abd_lookup.conf
  45. gnunet-abd --createIssuerSide --ego=gnunet --attribute="$MEMBER_ATTR" --subject="$GNUNET_KEY $USER_ATTR" --ttl="2019-12-12 10:00:00" -c test_abd_lookup.conf
  46. gnunet-namestore -D -z gnunet
  47. # (5) GNUnet signes the delegate and Alice stores it
  48. SIGNED=`$DO_TIMEOUT gnunet-abd --signSubjectSide --ego=gnunet --attribute=$DEV_ATTR --subject=$ALICE_KEY --ttl="2019-12-12 10:00:00"`
  49. gnunet-abd --createSubjectSide --ego=alice --import="$SIGNED" --private
  50. gnunet-namestore -D -z alice
  51. # Starting to resolve
  52. echo "+++ Starting to Resolve +++"
  53. DELS=`$DO_TIMEOUT gnunet-abd --collect --issuer=$SERVICE_KEY --attribute=$USER_ATTR --ego=alice --backward -c test_abd_lookup.conf | paste -d, -s - -`
  54. echo $DELS
  55. echo gnunet-abd --verify --issuer=$SERVICE_KEY --attribute=$USER_ATTR --subject=$ALICE_KEY --delegate=\'$DELS\' --backward -c test_abd_lookup.conf
  56. gnunet-abd --verify --issuer=$SERVICE_KEY --attribute=$USER_ATTR --subject=$ALICE_KEY --delegate="$DELS" --backward -c test_abd_lookup.conf
  57. RES=$?
  58. # Cleanup properly
  59. gnunet-namestore -z alice -d -n "@" -t DEL -c test_abd_lookup.conf
  60. gnunet-namestore -z gnu -d -n $GNU_PROJECT_ATTR -t ATTR -c test_abd_lookup.conf
  61. gnunet-namestore -z gnunet -d -n $MEMBER_ATTR -t ATTR -c test_abd_lookup.conf
  62. gnunet-namestore -z service -d -n $USER_ATTR -t ATTR -c test_abd_lookup.conf
  63. gnunet-arm -e -c test_abd_lookup.conf
  64. if [ "$RES" == 0 ]
  65. then
  66. exit 0
  67. else
  68. echo "FAIL: Failed to verify credential."
  69. exit 1
  70. fi